//**************************************************************
//		UART VAʐM
//**************************************************************
#include	<m8c.h>  
#include	"PSoCAPI.h"

//********************
//	݌v
//********************
//yӁz
//Ej[C
// Project >> Settings... >> Device Editor^u@ŁC
// Enable Interrupt Generation Control Ƀ`FbN邱ƁD
//--------------------
// UART ݒ (Placement , TX => DC12 , RX => DCB13)
//		Clock				DBB11 Broadcast  
//		RX Input			Global_IN_5   Port_1_3
//		TX Output			Global_OUT_7  Port_1_2
//		TX InterruptMode	TXComplete
//		RxCmdBuffer			Enable
//		RxBufferSize		127 Bytes
//		CommandTerminator	 13 (CR)
//		Param_Delimiter		 32 (space)
//		IgnoreCharsBelow	 32 (Ignore all chars below space, except CR)

//********************
// SysCLK = 12.8MHz̏ꍇ
//********************
// Counter8 ݒ
//		Counter8_CLK_UART  (placed in DBB11)
//		Clock         25.6MHz (SysCLK * 2)
//		Enable        High  
//		Output        None  
//		Period        82
//		CompareValue  41
//		CompareType   Less Than Or Equal
//		InterruptType Terminal Count
//--------------------
// Baud Rate
//		Using the settings above the UART baud rate can be calculated.
//		baud rate = 25.6MHz / ((Period+1) * (over Sample rate))
//		baud rate = 25.6MHz / (( 82+1) * 8) = 38554 Baud ...  +0.4%
//		Counter8.Period  =  82  -->  38400 Baud
//		baud rate = 25.6MHz / ((165+1) * 8) = 19277 Baud ...  +0.4%
//		Counter8.Period  = 165  -->  19200 Baud
//--------------------

//********************
// SysCLK = 24MHz̏ꍇ
//********************
// Counter8 ݒ
//		Counter8_CLK_UART  (placed in DBB11)
//		Clock         48MHz (SysCLK * 2)
//		Enable        High  
//		Output        None  
//		Period        155
//		CompareValue  77
//		CompareType   Less Than Or Equal
//		InterruptType Terminal Count
//--------------------
// Baud Rate
//		Using the settings above the UART baud rate can be calculated.  
//		baud rate = 48MHz / ((Period+1) * (over Sample rate))  
//		baud rate = 48MHz / (( 155+1) * 8) = 38462 Baud ...  +0.16%
//		Counter8.Period  =  155  -->  38400 Baud


//*********************
// UART_1 ( Counter8_CLK_UART) 
//*********************
void init_UART(void) {
	UART_1_CmdReset();						// Initialize receiver/cmd buffer
	UART_1_IntCntl(UART_1_ENABLE_RX_INT);	// Enable RX interrupts  
	Counter8_CLK_UART_Start();				// Turn on baud rate generator
	UART_1_Start(UART_PARITY_NONE);			// Enable UART  
}


